//////////////////////////////////////////////////////////////
//Rechnen mit sovielen Threads wie der Prozessor Kerne hat.
//Aus Kapitel Nebenläufige Programmierung
// Berechne irgend etwas, das viel Zeit braucht
// und nicht vom Java-Übersetzer optimiert werden kann 
/////////////////////////////////////////////////////////////

public class MyThread extends Thread {

  public double res=0;
  long iterations;

  // Thread anlegen und Parameter übergeben
  public MyThread(long iter){
    iterations = iter;
  }

  // computeSomething() in neuer Form
  public void run(){
   for (long i=1; i < iterations; i++ ) 
      res += Math.sin((double)(i));    
    println(res);
  }
}

/////////////////////////////////////////////////////////////////

void setup() {
  ArrayList<MyThread> workers = new ArrayList<MyThread>();
  boolean finished;

  int processors = Runtime.getRuntime().availableProcessors();
  println("Der Prozessor hat " + processors + " Kerne");

  // starte so viele rechenintensive Threads, 
  // wie der Rechner Kerne hat
  for (int i=0; i<processors; i++) {
    MyThread t = new MyThread(10000000+i);
    // nun starte den Thread:
    t.start();
    workers.add(t); 
  }

  do  {
    // prüfe, ob alle Prozesse schon fertig sind
    finished = true;
    for (MyThread worker : workers) 
        if (worker.isAlive()) finished = false; 
    
    // warte ein wenig, damit nicht zu viele Nachfragen
    // den Rechner blockieren
    delay(10);
  } while (!finished);

  double r = 0;
  for (MyThread worker : workers)
    r += worker.res; 

  println("Gesamtzeit: " +millis()/1000.0 + " Sekunden  Ergebnis: " + r);
}